repos:

- repo: https://github.com/pre-commit/pre-commit-hooks
  rev: v4.5.0
  hooks:
    - id: trailing-whitespace
    - id: end-of-file-fixer
      exclude: LICENSES/headers
    - id: check-yaml
      # !reference is specific to gitlab
      exclude: \.gitlab-ci.yml
    - id: check-added-large-files
    - id: check-json
    - id: pretty-format-json
      args: [
        --autofix,
        --no-sort-keys,
      ]
    - id: check-toml
    - id: destroyed-symlinks
    - id: check-symlinks

- repo: https://github.com/pre-commit/pygrep-hooks
  rev: v1.10.0
  hooks:
    - id: rst-backticks
    - id: rst-directive-colons
    - id: rst-inline-touching-normal

- repo: https://github.com/myint/docformatter
  rev: v1.7.5
  hooks:
    - id: docformatter
      args: [
        --in-place,
        --black,
      ]

- repo: https://github.com/astral-sh/ruff-pre-commit
  rev: v0.1.13
  hooks:
    - id: ruff
      args: [
        --fix,
        --preview,
        --exit-non-zero-on-fix,
      ]

- repo: https://github.com/astral-sh/ruff-pre-commit
  rev: v0.1.13
  hooks:
    - id: ruff-format

- repo: https://github.com/commitizen-tools/commitizen
  rev: v3.13.0
  hooks:
    - id: commitizen
      stages: [commit-msg]

- repo: https://github.com/kynan/nbstripout
  rev: 0.6.1
  hooks:
    - id: nbstripout

- repo: https://github.com/nbQA-dev/nbQA
  rev: 1.7.1
  hooks:
    - id: nbqa-black
    - id: nbqa-pyupgrade
      args: [ "--py39-plus" ]
    - id: nbqa-autopep8

- repo: https://github.com/igorshubovych/markdownlint-cli
  rev: v0.38.0
  hooks:
  - id: markdownlint
    args: ["--fix"]

- repo: https://github.com/Lucas-C/pre-commit-hooks
  rev: v1.5.4
  hooks:
    - id: insert-license
      name: insert LGPL license
      exclude: ^doc_src
      files: \.py$
      args:
        - --license-filepath
        - LICENSES/headers/LGPL-3.0.txt
    - id: insert-license
      name: insert BSD license
      files: ^doc_src/(_examples|tutorials).*\.py$
      args:
        - --license-filepath
        - LICENSES/headers/BSD-0-Clause.txt
    - id: insert-license
      name: insert CC BY-SA license for rst files
      files: \.rst$
      args:
        - --license-filepath
        - LICENSES/headers/CC-BY-SA-4.0.txt
        - --comment-style
        - ..|   |
    - id: insert-license
      name: insert CC BY-SA license for md files
      files: \.md$
      args:
        - --license-filepath
        - LICENSES/headers/CC-BY-SA-4.0.txt
        - --comment-style
        - <!--||-->
